;**************************************************
;*****                                        *****
;*****   RAE-1  DUMP AND LOAD ROUTINES        *****
;*****   USING HYPERTAPE INTERFACE            *****
;*****   WRITTEN BY TH.G. DRIEVER  15-1-'85   *****
;*****                                        *****
;**************************************************
;
 .CE
 .BA $A000
 .OS
;
;
;
;ZERO PAGE
;
POINTL .DE $FA ;ADDRESS POINTER
POINTH .DE POINTL+1
;
;PARAMETERS
;
LOAD/NO .DE $123 ;IF 0, DO NOT STORE
TSTART .DE LOAD/NO+1 ;START ADDRESS
TEND .DE TSTART+2 ;END ADDRESS
;
;DATA BUFFERS
;
SY .DE $1A69 ;SYN COUNTER
BYTE .DE SY+1 ;BYTE FROM TAPE
CHKL .DE BYTE+4 ;CHECKSUM
CHKH .DE CHKL+1
;
SYNCNT .DE CHKH+5 ;SYN COUNTER
BITS .DE SYNCNT+1 ;# OF BITS
GANG .DE BITS+3 ;TEMP FOR PBD-BITS
;
;PIA ADDRESSES
;
PAD .DE $1A80 ;PORT A DATA
PADD .DE PAD+1 ;PORT A DIRECTION
PBD .DE $1A82 ;PORT B DATA
PBDD .DE PBD+1 ;PORT B DIRECTION
;
;TIMER
;
CNTA .DE $1AF4 ;CLK1T IRQ DISABLED
CNTC .DE $1AF6 ;CLK64T IRQ DISABLED
RDFLAG .DE $1AD5 ;TIMER FLAG = BIT 7
RDTDIS .DE $1AD4 ;READ TIMER IRQ DISABLED
;
;
;
;********* DUMP *********
;
DUMP LDA PBDD ;PB7=OUTPUT
 ORA #%10000000
 STA PBDD
 LDA #0
 STA CHKL ;RESET CHECKSUM
 STA CHKH
 LDA TSTART ;INIT DUMP POINTER
 STA *POINTL
 LDA TSTART+1
 STA *POINTH
 LDX #120 ;SET SYNC COUNTER
 STX SYNCNT
;
SYNCS LDA #$16 ;ASCII SYN CHAR
 JSR OUTBT ;OUTPUT 255 SYNC'S
 DEC SYNCNT
 BNE SYNCS
;
 LDA #'# ;OUTPUT START CHARACTER
 JSR OUTBT
;
DATATR LDA *POINTH
 CMP TEND+1 ;ENTIRE FILE DUMPED?
 BNE HEXDAT
 LDA *POINTL
 CMP TEND
 BNE HEXDAT
;
 LDA CHKL ;DUMP CHECKSUM
 JSR OUTBT
 LDA CHKH
 JSR OUTBT
;
 LDA #$04 ;EOT CHARACTER
 JSR OUTBT
;
 LDA PBDD ;PB7=INPUT FOR LOAD
 AND #%01111111
 STA PBDD
 RTS
;
HEXDAT LDY #0
 LDA (POINTL),Y ;FETCH DATA BYTE
 JSR OUTBTC ;DUMP IT
 INC *POINTL ;SET POINTER ON
 BNE DATATR ;NEXT DATA BYTE
 INC *POINTH
 JMP DATATR
;
;
;OUTBTC DUMPS A BYTE AND UPDATES CHECKSUM
;
OUTBTC TAY ;SAVE DATA BYTE
 CLC
 ADC CHKL ;COMPUTE CHECKSUM
 STA CHKL
 LDA CHKH
 ADC #0
 STA CHKH
 TYA ;GET DATA BYTE
;
;OUTBT IS THE ENTRY FOR DUMP WITHOUT
;CHECKSUM COMPUTATION
;
OUTBT LDX #8 ;SET UP FOR 8 BITS
 STX BITS
ONE LSR A ;SHIFT BITS OUT
 PHA ;SAVE BYTE
 BCC ZERO
 JSR HIGH ;1=HIGH-LOW-LOW
 JSR LOW
 JSR LOW
 JMP ZRO
;
ZERO JSR HIGH ;0=HIGH-HIGH-LOW
 JSR HIGH
 JSR LOW
;
ZRO PLA ;GET BYTE AGAIN
 DEC BITS ;ALL BITS DUMPED?
 BNE ONE
 RTS
;
;HIGH :3 PERIODS OF 3600 Hz
;
HIGH LDX #3 ;AMOUNT OF HALF PERIODS
HIG BIT RDFLAG ;TIME OUT?
 BPL HIG
 LDA #125 ;SET UP TIMER FOR SHORT PERIOD
 STA CNTA ;IRQ DISABLED, CLK1T
 LDA PBD
 EOR #%10000000 TOGGLE OUTPUT
 STA PBD
 DEX
 BNE HIG
 RTS
;
;LOW: 2 PERIODS OF 2400 Hz
;
LOW LDX #2 ;AMOUNT OF HALF PERIODS
LO BIT RDFLAG ;TIME OUT
 BPL LO
 LDA #195 ;SET UP TIME FOR LONG PERIODE
 STA CNTA
 LDA PBD
 EOR #%10000000 TOGGLE
 STA PBD
 DEX
 BNE LO
 RTS
;
;********* LOAD *********
;
RDTAPE LDA PBDD ;DISABLE TTY OUTPUT
 AND #%01111110 BE SURE PB7=INPUT
 STA PBDD
 LDA PBD
 AND #%11100001 STROBE 9 (5E DISPLAY)
 ORA #%00010010
 STA PBD
 STA GANG ;SAVE STATUS QUO
;
 LDA TSTART ;INIT LOAD POINTER
 STA POINTL
 LDA TSTART+1
 STA POINTH
;
 LDA #0
 STA CHKL ;RESET CHECKSUM
 STA CHKH
;
SYNC LDA #%00110110 NO SYNC PATTERN
 STA PAD
 LDA #$FF ;NO SYNC IN BYTE
 STA BYTE
;
SYNCA JSR RDBIT ;READ A BIT FROM TAPE
 ROR BYTE ;RIGHT SHIFT
 LDA BYTE ;GET CURRENT BYTE
 JSR VU ;DISPLAY NOT SYN CHAR
 CMP #$16 ;ASCII SYN?
 BNE SYNCA ;IF NOT RESYNC
 LDY #10 ;TRY IT FOR 10 SYNS AT LEAST
 STY SY ;SYN COUNTER
;
TENSYN JSR RDBYT
 JSR CHARVU ;DISPLAY SYN CHAR
 CMP #$16 ;STILL SYN?
 BNE SYNC ;IF NOT RETURN
 DEC SY ;10 SYNS RECEIVED?
 BNE TENSYN ;RETURN WHILE NOT TEN SYNS
;
STAR JSR RDBYT ;WAIT FOR '#' CHAR
 JSR CHARVU
 CMP #$16 ;STILL SYN?
 BEQ STAR ;THEN WAIT FOR #
 CMP #'# ;START OF DATA?
 BEQ FILMEM
 BNE RDTAPE ;ELSE START OVER
;
FILMEM JSR RDBYT ;READ DATA BYTE
 JSR CHKSUM
 TAY ;SAVE BYTE
 LDA LOAD/NO
 BEQ INCPNT
 TYA
 LDY #0
 STA (POINTL),Y STORE BYTE IN MEMORY
INCPNT INC *POINTL ;SET POINTER ON
 BNE FMA ;NEXT DATA BYTE
 INC *POINTH
;
FMA JSR VU ;DISPLAY #
 LDA POINTL ;FINISHED?
 CMP TEND
 BNE FILMEM
 LDA POINTH
 CMP TEND+1
 BNE FILMEM ;READ NEXT DATA BYTE
;
 JSR RDBYT ;READ CHECKSUM FROM TAPE
 EOR CHKL
 STA CHKL
 JSR RDBYT
 EOR CHKH
 ORA CHKL
 PHA
 LDA PBDD ;ENABLE TTY OUTPUT
 ORA #%00000001
 STA PBDD
 LDA PBD ;DISABLE DISPLAYS
 AND #%11100001
 ORA #%00000110
 STA PBD
 LDA #0
 STA PAD
;
 PLA ;CLEAR Z IF CHECKSUM ERROR
 RTS ;RETURN
;
;RDBIT READS 1 BIT FROM TAPE
;CARRY = BIT FOUND
;
RDBIT BIT PBD ;3600 Hz? (=1 FROM PLL)
 BPL RDBIT
 LDA RDTDIS ;GET COUNT DOWN
 LDY #255
 STY CNTC ;2400 Hz COUNT DOWN
 LDY #20
;
RDBA DEY ;DELAY JITTER TIME
 BNE RDBA
;
RDBB BIT PBD ;2400 Hz?
 BMI RDBB
 SEC
 SBC RDTDIS ;SET OR RESET C-FLAG
 LDY #255
 STY CNTC ;3600 Hz COUNT DOWN
 LDY #7 ;DELAY FOR JITTER
;
RDBC DEY
 BNE RDBC
 RTS
;
;RDBYT READS A BYTE FROM TAPE AND RETURNS IT
;IN ACCU
;
RDBYT LDX #8 ;SET UP FOR 8 BITS
;
READ JSR RDBIT ;READ A BIT FROM TAPE
 ROR BYTE ;SHIFT BIT INTO BYTE
 DEX ;ALL BITS RECEIVED?
 BNE READ
 LDA BYTE ;STORE IT IN ACCU
 RTS
;
CHKSUM PHA ;SAVE BYTE
 CLC
 ADC CHKL ;CHK +:= BYTE
 STA CHKL
 LDA CHKH
 ADC #0
 STA CHKH
 PLA ;RESTORE BYTE
 RTS
;
;
;CHARVU PUTS A PATTERN ON 7-SEGMENTS DISPLAY
;CORRESPONDING TO THE RECEIVED CHARACTER
;VU IS THE ENTRY TO FLIP-FLOP THE DISPLAYS
;WITHOUT CHANGING THE PATTERN.
;
CHARVU PHA ;SAVE BYTE
 EOR #$7F ;INVERTED TO SEGMENTS
 STA PAD ;
 PLA ;RESTORE BYTE
;
VU PHA
 LDA GANG
 AND #%00000010
 BNE VU1
 LDA GANG
 EOR #%00000010
 BNE VU2
VU1 LDA GANG
 EOR #%00011110
VU2 STA PBD
 STA GANG ;SAVE STATUS QUO
 PLA
 RTS
;
;
SETSAVE LDA #L,DUMP
 STA $9A
 LDA #H,DUMP
 STA $9B
 RTS
;
SETLOAD LDA #L,RDTAPE
 STA $97
 LDA #H,RDTAPE
 STA $98
 RTS
;
;
 .EN
